mf.ui = {} --The help dialog
--local mui = tcs.mf.ui --Binding for main UI
mf.ui.halpmsg = "Welcome to Make Friends, the radar customization applet!\n\n\tThe main window lets you select what overall groups/factions appear red or green on your radar. If the toggle is colored red, it will appear red on your radar. Likewise if the toggle is colored green. \"Categories\" toggles and \"NPCs\" controls take precedence over \"Factions\" toggles- namely, if you have certain NPC's or your guildmates set as friendly/green, then you can't turn those NPCs or your guildmates red no matter what factions you configure to be hostile. \n\n\tA note about the \"Conquerable Assets\": MakeFriends doesn't yet have full support to figure out who has the right IFF settings in a conquerable sector, but it can figure out if the turrets hate you or not as long as the relevant key has a location formatted like 'Latos I-8' in the key name. Having MakeFriends treat the turrets \"As Player\" enables this logic. This logic does not affect station guards in conquerable sectors.\n\n\tThe Friends and Enemies lists windows allows you to specify people or guilds who are always green or always red on radar, respectively. The enemies list takes precedence over the friends list, so any person or guild on the enemies list is always red even if you have them put down in the friends list eighty times. To ignore your friends and enemies lists, for Nation War or some other team event, check the relevant toggles in the main window. Click on the \"Edit Lists\" button to access the edits for manual editing of these lists. Use the \"Edit People Lists\" button to manage individual players, and the \"Edit Guild Lists\" to manage guilds. Do not use quotes when entering players who have more than one word in their name, and on the guilds list, only use the acronym of a guild when adding entries.\n\n\tThe toggles on the bottom-left of the main window are used, respectively, to:\n\t\t- Pretend your enemy players list is empty\n\t\t- Pretend your enemy guilds list is empty\n\t\t- Pretend your friendly players list is empty\n\t\t- Pretend your friendly guilds list is empty\n\t\t- Take a player\'s faction standing into account when showing them on the radar\n\t\t- If you are hit by another player they will be red for the amount of time displayed\n\t\tin the box, and if you hit another player, your CURRENT TARGET will be red for\n\t\thowever many minutes are displayed in the box\n\n\tThe Save Presets button will prompt you for a name to save your current toggle settings as. WARNING: Save Presets button will overwrite presets without warning. \n\n\tEdit Presets allows you to load or delete presets, or load the \'current\' defaults. If you have no presets or have just loaded the default presets, any changes you make to the toggles in the main window will be reflected in the default preset once you hit \"OK\". It is suggested that you make the defaults a setting you usually fly around as, and use presets for special circumstances(such as events).\n\n\tLastly, hit \"OK\" to save everything and all that good stuff.\n\n\tFor more advanced users, you can also use the following commands to reset lists of people who have hit you and are thusly marked red.\n\t\t- /makefriends reset player\n\t\t- /makefriends reset npc\n\t\t- /makefriends reset all\n\n\tThe commands are a bit slipshod, but do as they say on the tin. Good luck!\n\n\n\nCredits:\nWritten by Scuba Steve 9.0.\nPre-TCS version 1.3.1 modified by raybondo.\nHelpfile for Pre-TCS MF v1.5.0 updated by Miharu."

mf.ui.mcontrols = {
	--Only place elements with 'title' as a basic element in this group. Too lazy to actually add in the edge cases. Oh well.
	--NPC = 		{"stationtoggle", title = "NPC\s", args = {fgcolor="255 0 0"}},
	guild = 	{"stationtoggle",{title = "Guild Members",fgcolor = "255 0 0"}},
	group = 	{"stationtoggle",{title = "Group Members",fgcolor="255 0 0"}},
	buddies = 	{"stationtoggle",{title = "Buddies",fgcolor="255 0 0"}},
	serco = 	{"stationtoggle", {title = "Serco Dominion",fgcolor="255 0 0" }},
	itani = 	{"stationtoggle", {title = "Itani Nation",fgcolor="255 0 0" }},
	uit = 		{"stationtoggle", {title = "Union of Independent Territories",fgcolor="255 0 0" }},
	aeolus = 	{"stationtoggle", {title = "Aeolus Trading Prefectorate",fgcolor="255 0 0" }},
	xangxi = 	{"stationtoggle", {title = "Xang Xi Automated Systems",fgcolor="255 0 0" }},
	biocom = 	{"stationtoggle", {title = "Biocom Industries",fgcolor="255 0 0" }},
	ineubis = 	{"stationtoggle", {title = "Ineubis Defense Research",fgcolor="255 0 0" }},
	valent = 	{"stationtoggle", {title = "Valent Robotics",fgcolor="255 0 0" }},
	axia = 		{"stationtoggle", {title = "Axia Technology Corp",fgcolor="255 0 0" }},
	corvus = 	{"stationtoggle", {title = "Corvus Prime",fgcolor="255 0 0" }},
	tunguska =	{"stationtoggle", {title = "Tunguska Heavy Mining Concern",fgcolor="255 0 0" }},
	orion = 	{"stationtoggle",{title = "Orion Heavy Manufacturing", fgcolor="255 0 0" }},
	unaligned=	{"stationtoggle", {title = "Unaligned", fgcolor="255 0 0" }},
	tpg = 		{"stationtoggle",{title = "TPG Corporation", fgcolor="255 0 0" }},
	
	hivestat = 	{"label", {title = "Hivebots", fgcolor="255 204 241"}},
	statgstat = {"label", {title = "Station Guards",fgcolor="255 204 241"}},
	sfstat = 	{"label", {title = "Strike Force", fgcolor="255 204 241"}},
	borderstat= {"label", {title = "Faction Defense Turrets", fgcolor="255 204 241"}},
	conqstat = 	{"label", {title = "Conquerable Assets", fgcolor="255 204 241"}},
	normstat = 	{"label", {title = "Other NPCs", fgcolor="255 204 241"}},
	hive = 		{"stationsubsublist", {dropdown = "YES", [1] = "\127FFCCF1As Player", [2] = "\127ff0000Hostile", [3] = "\12700ff00Friendly", [4] = "\127ffffffUse Faction Standing Only"}},
	statg = 	{"stationsubsublist", {dropdown = "YES", [1] = "\127FFCCF1As Player", [2] = "\127ff0000Hostile", [3] = "\12700ff00Friendly", [4] = "\127ffffffUse Faction Standing Only"}},
	sf = 		{"stationsubsublist", {dropdown = "YES", [1] = "\127FFCCF1As Player", [2] = "\127ff0000Hostile", [3] = "\12700ff00Friendly", [4] = "\127ffffffUse Faction Standing Only"}},
	border =	{"stationsubsublist", {dropdown = "YES", [1] = "\127FFCCF1As Player", [2] = "\127ff0000Hostile", [3] = "\12700ff00Friendly", [4] = "\127ffffffUse Faction Standing Only"}},
	conq = 		{"stationsubsublist", {dropdown = "YES", [1] = "\127FFCCF1As Player", [2] = "\127ff0000Hostile", [3] = "\12700ff00Friendly", [4] = "\127ffffffUse Faction Standing Only"}},
	norm = 		{"stationsubsublist", {dropdown = "YES", [1] = "\127FFCCF1As Player", [2] = "\127ff0000Hostile", [3] = "\12700ff00Friendly", [4] = "\127ffffffUse Faction Standing Only"}},
	
	igfriend =	{"stationtoggle",{ title = "Ignore Friend Players List",fgcolor="255 255 255" }},
	igenemy = 	{"stationtoggle", {title = "Ignore Enemy Players List",fgcolor="255 255 255" }},
	igfriendguild = 	{"stationtoggle", {title = "Ignore Friend Guilds List",fgcolor="255 255 255" }},
	igenemyguild = 		{"stationtoggle", {title = "Ignore Enemy Guilds List",fgcolor="255 255 255" }},
	flaghostile = 		{"stationtoggle", {title = "Set hostiles red for ",fgcolor="255 255 255" }},
	considerstanding =	{"stationtoggle", {title = "Consider Faction Standings.", fgcolor = "255 255 255" }},
	groupstitle = 		{"label", {title="Categories"}},
	factionstitle = 	{"label", {title = "Factions"} },
	npcstitle =			{"label", {title = "NPCs"} },
	halpb = 			{"stationbutton", {title = "Help"}},
	makefriendsb = 		{"stationbutton", {title = "OK"} },
	closeb = 			{"stationbutton", {title = "Close"}},
	listsopenb = 		{"stationbutton", {title = "Edit Lists", expand = "HORIZONTAL" }},
	savepresetb = 		{"stationbutton", {title = "Save as Preset"}},
	presetsb = 			{"stationbutton", {title = "Edit Presets"}},
	fandeopenb = 		{"stationbutton", {title = "Edit People Lists", expand = "HORIZONTAL" }},
	guildopenb = 		{"stationbutton", {title = "Edit Guild Lists", expand = "HORIZONTAL" }}
}

function mf.BatchAddControls(batch_struct, host_table) 
	for name, attrib in pairs(batch_struct) do
		local elem = iup[attrib[1]](attrib[2])
		host_table[name] = elem
	end
end

mf.BatchAddControls(mf.ui.mcontrols, mf.ui)

function mf.close()--need to rename
	HideDialog(mf.ui.presetsdlg)
	HideDialog(mf.ui.fandedlg)
	HideDialog(mf.ui.dlg)
	mf.cli_menu_adjust(mf.name)--still needs modified
end

function mf.ui.closeb:action()
	mf.close()
end

function mf.ui.halpb:action()
	StationHelpDialog:Open(mf.ui.halpmsg)
end


function mf.ui.fandeopenb:action()
	mf.ui.fandedlgopen()
end

function mf.ui.guildopenb:action()
	mf.ui.guildlistsdlgopen()
end

function mf.ui.presetsb:action()
	mf.ui.presetsdlgopen()
	iup.SetAttribute(mf.ui.dlg, "ACTIVE", "NO")
end

--For the sake of not going insane while rewriting MF
function mf.ToggleStateToBool(state)
	if state == "ON" then return true end
	return false
end

--TODO: Move this into batch table above and convert values not in batch tables below to batch tables
mf.ui.flaghostiletext = iup.text { value = "", size = "50x" }
mf.ui.titlepadding = iup.fill {}
mf.ui.groupsspacer = iup.fill {}
mf.ui.npcsspacer = iup.fill {}
mf.ui.factionsspacer = iup.fill { size = "5"} -- Lisa changed from 20 for android spacing

local elems = {
	mf.ui.groupstitle,
	iup.hbox {
		iup.vbox{
			mf.ui.guild,
			mf.ui.buddies
		},
		mf.ui.groupsspacer,
		iup.vbox{
			mf.ui.group,
			--mf.ui.NPC
		},
		iup.fill{},
	},
	mf.ui.npcstitle,
	iup.hbox {
		iup.fill{size="17"},
		iup.vbox{
			mf.ui.hivestat,
			mf.ui.statgstat,
			mf.ui.sfstat,
			mf.ui.conqstat,
			mf.ui.borderstat,
			mf.ui.normstat
		},
		mf.ui.npcsspacer,
		iup.vbox{
			mf.ui.hive,
			mf.ui.statg,
			mf.ui.sf,
			mf.ui.conq,
			mf.ui.border,
			mf.ui.norm
		},
		iup.fill{}
	},
	mf.ui.factionstitle,
	iup.hbox {
		iup.vbox{
			mf.ui.itani,
			mf.ui.uit,
			mf.ui.valent,
			mf.ui.biocom,
			mf.ui.corvus,
			mf.ui.aeolus,
			mf.ui.tunguska,
		},
		mf.ui.factionsspacer,
		iup.vbox{
			mf.ui.serco,
			mf.ui.tpg,
			mf.ui.axia,
			mf.ui.orion,
			mf.ui.xangxi,
			mf.ui.ineubis,
			mf.ui.unaligned,
		},
		iup.fill{}
	},
	iup.fill { size = "5" },
	iup.hbox{
		iup.vbox {
			mf.ui.igenemy,
			mf.ui.igenemyguild,
			mf.ui.igfriend,
			mf.ui.igfriendguild,
			mf.ui.considerstanding,
			iup.hbox {
				mf.ui.flaghostile,
				mf.ui.flaghostiletext,
				iup.label { title = " mins."}
			}
		},
		iup.fill {},
		iup.vbox {
			iup.fill{},
			mf.ui.savepresetb,
			mf.ui.presetsb;
		}
	},
	iup.fill {},
	iup.hbox {
		mf.ui.halpb,
		mf.ui.fandeopenb,
		mf.ui.guildopenb,
		mf.ui.makefriendsb,
		mf.ui.closeb
	};
	alignment = "ACENTER"
}

function mf.ConfigConstructor(title, elements, maindlgops)
	local maindlg = iup.dialog{
		iup.stationhighopacityframe{
			iup.stationhighopacityframebg{
				iup.vbox {
					iup.hbox{iup.fill{},iup.label{title=title,font=Font.H3},iup.fill{}},
					unpack(elements)
				}
			}
		},
		menubox="NO",
		resize="NO",
		border="NO",
		defaultesc=mf.ui.closeb,
		bgcolor = "0 255 0 255 *",
		topmost = "yes"
	}
	return maindlg
end

mf.ui.dlg = mf.ConfigConstructor("MakeFriends TGFT "..mf.version.." Config", elems, {defaultesc=mf.ui.closeb})

--Nabs the size of a iup element. Returns int width, int height
function mf.GetElementSize(element)
	local width = string.gsub(element.size, "x%d+", "")
	local heighth = string.gsub(element.size, "%d+x", "")
	return tonumber(width), tonumber(heighth) 
end

function mf.ui.dlg:init()
	iup.Map(mf.ui.dlg)
	mf.GetFriends()--this is in make_friends.lua
	local closesavewidth = mf.GetElementSize(mf.ui.closeb) + mf.GetElementSize(mf.ui.makefriendsb)
	mf.ui.savepresetb.size = closesavewidth .. "x"
	mf.ui.presetsb.size = closesavewidth .. "x"
	mf.ui.groupsspacer.size = tostring(mf.GetElementSize(mf.ui.uit) + mf.GetElementSize(mf.ui.factionsspacer) - mf.GetElementSize(mf.ui.guild))
	iup.Refresh(mf.ui.dlg)
end

--Determines what to show after a dialog closes
function mf.cli_menu_adjust(name)
	if not mf.PROVIDED[name].cli then ShowDialog(mf.ui.confdlg)--still needs modified
	else 
		mf.PROVIDED[name].cli = nil
		local incap = GetCurrentStationType() == 1
		local instation = PlayerInStation()
		if incap then
			ShowDialog()
		elseif instation and not incap then 
			ShowDialog(StationDialog)
		elseif not (instation and incap) then
			ShowDialog(HUD)
		end
	end
end

function mf.ui.makefriendsb:action()
	mf.factions[2] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.serco, "VALUE")) 
	mf.factions[1] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.itani, "VALUE")) 
	mf.factions[3] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.uit, "VALUE")) 
	mf.factions[11] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.aeolus, "VALUE")) 
	mf.factions[12] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.ineubis, "VALUE")) 
	mf.factions[6] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.valent, "VALUE")) 
	mf.factions[8] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.axia, "VALUE")) 
	mf.factions[5] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.biocom, "VALUE"))
	mf.factions[4] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.tpg, "VALUE")) 
	mf.factions[7] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.orion, "VALUE"))
	mf.factions[9] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.corvus, "VALUE")) 
	mf.factions[0] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.unaligned, "VALUE")) 
	mf.factions[10] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.tunguska, "VALUE"))
	mf.factions[13] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.xangxi, "VALUE")) 
	mf.FS["Group"] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.group, "VALUE"))
	mf.FS["Guild"] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.guild, "VALUE"))
	mf.FS["Buddy"] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.buddies, "VALUE"))
	--mf.FS["NPC"] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.NPC, "VALUE"))
	mf.FS["Hive"] = tonumber(iup.GetAttribute(mf.ui.hive, "VALUE"))
	mf.FS["StatG"] = tonumber(iup.GetAttribute(mf.ui.statg, "VALUE"))
	mf.FS["SF"] = tonumber(iup.GetAttribute(mf.ui.sf, "VALUE")) 
	mf.FS["Border"] = tonumber(iup.GetAttribute(mf.ui.border, "VALUE")) 
	mf.FS["Conq"] = tonumber(iup.GetAttribute(mf.ui.conq, "VALUE")) 
	mf.FS["norm"] = tonumber(iup.GetAttribute(mf.ui.norm, "VALUE"))
	mf.FS["igEnemy"] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.igenemy, "VALUE"))
	mf.FS["igFriend"] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.igfriend, "VALUE"))
	mf.FS["igEnemyGuild"] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.igenemyguild, "VALUE"))
	mf.FS["igFriendGuild"] = mf.ToggleStateToBool(iup.GetAttribute(mf.ui.igfriendguild, "VALUE"))
	mf.FS["FlagHostile"] = mf.ToggleStateToBool(mf.ui.flaghostile.value)
	mf.LastAggro.timeout = mf.ui.flaghostiletext.value * 60
	mf.FS["ConsiderStanding"] = mf.ToggleStateToBool(mf.ui.considerstanding.value)
	mf.invalidate_conq_status(nil, nil)
	mf.close()
	mf.SaveSettings(mf.curpreset)--rename
end

--Guild lists dialog, go~!
mf.ui.gcontrols = {
	guildlistscloseb =	{"stationbutton", {title =  "Close & Save",expand = "HORIZONTAL" }},
	whitetoblackb = 	{"stationbutton", {title =  ">" }},
	blacktowhiteb = 	{"stationbutton", {title =  "<" }},
	addwhite = 			{"stationbutton", {title =  "Add as Friendly Guild",expand = "HORIZONTAL" }},
	addblack = 			{"stationbutton", {title =  "Add as Enemy Guild",expand = "HORIZONTAL" }},

	removewhite = 	{"stationbutton", {title =  "Remove Friendlly Guild",expand = "HORIZONTAL"}},
	removeblack = 	{"stationbutton", {title =  "Remove Enemy Guild",expand = "HORIZONTAL"}}
}

mf.BatchAddControls(mf.ui.gcontrols, mf.ui)

mf.ui.blacklist = iup.pdasubsubsublist { value = 0, size = "x160", expand = "HORIZONTAL" }
mf.ui.whitelist = iup.pdasubsubsublist { value = 0, size = "x160", expand = "HORIZONTAL" }
mf.ui.whiteentry = iup.text { value = "", expand = "HORIZONTAL"}
mf.ui.blackentry = iup.text { value = "", expand = "HORIZONTAL"}


mf.ui.whitelistcomp = iup.vbox {
	iup.label { title = "Friendly Guilds"},
	mf.ui.whitelist,
	mf.ui.whiteentry,
	mf.ui.addwhite,
	mf.ui.removewhite;
	alignment = "ACENTER"
}
mf.ui.blacklistcomp = iup.vbox {
	iup.label { title = "Enemy Guilds"},
	mf.ui.blacklist,
	mf.ui.blackentry,
	mf.ui.addblack,
	mf.ui.removeblack;
	alignment = "ACENTER"
}

mf.ui.xferbuttons = iup.vbox {
	iup.fill{},
	mf.ui.whitetoblackb,
	mf.ui.blacktowhiteb,
	iup.fill{}
}

mf.ui.guildlistsmain = iup.pdarootframe {
	iup.pdasubframebg {
		iup.vbox{
			iup.hbox {
				mf.ui.whitelistcomp,
				mf.ui.xferbuttons,
				mf.ui.blacklistcomp
			},
			iup.fill{},
			iup.hbox {
				mf.ui.guildlistscloseb;
			};
			alignment = "ACENTER"
		}
	}
}

mf.ui.guildlistsdlg = iup.dialog {
	mf.ui.guildlistsmain;
	border = "NO",
	topmost = "YES",
	resize = "NO",
	maxbox = "NO",
	minbox = "NO",
	menubox = "NO",
	MODAL = "YES"
}

function mf.ui.guildlistsdlgopen()
	for key, value in pairs(mf.friendguildlist) do
		mf.PushListItem(mf.ui.whitelist, value)
	end
	for key, value in pairs(mf.enemyguildlist) do
		mf.PushListItem(mf.ui.blacklist, value)
	end	
	ShowDialog(mf.ui.guildlistsdlg)
end

--Accurately determines what the VALUE attribute of a list should be.
function mf.GetListSize(list)
	local val = 0
	while(list[val + 1] ~= nil) do
		val = val + 1
	end
	return val
end

--Removes the selected item from a list if sel is not specified
--Otherwise, it removes the item at the value of vo_listsel(currently selected item)
--If an item hasn't been selected, removes the last item in the list.
--Returns the value of the item removed
function mf.RemoveSelectedListItem(list, sel)
	if(sel == nil) then
		sel = list.vo_listsel
	end
	if(sel ~= 0) then
		local val = mf.GetListSize(list)
		if(not sel) then sel = val end
		local curval = list[tostring(sel)]
		while(tonumber(sel) < val) do
			list[sel] = list[sel + 1]
			sel = sel + 1

		end
		list[tostring(val)] = nil
		list.value = val - 1
		list.vo_listsel = sel - 1
		return curval
	end
end

--Converts our black/whitelists to maps to simplify comparisons. Uses ipairs
function mf.iListToMap(list)
	--reset map
	local map = {}
	for dex, val in ipairs(list) do
		map[string.lower(val)] = true
	end
	return map
end

function mf.ui.guildlistscloseb:action()
	mf.enemyguildlist = {}
	mf.friendguildlist = {}
	local nam = ""
	local listcounter = mf.GetListSize(mf.ui.whitelist)
	while(listcounter > 0) do
		nam = mf.RemoveSelectedListItem(mf.ui.whitelist, 1)
		table.insert(mf.friendguildlist, nam)
		listcounter = listcounter - 1

	end
	listcounter = mf.GetListSize(mf.ui.blacklist)
	while(listcounter > 0) do
		nam = mf.RemoveSelectedListItem(mf.ui.blacklist, 1)
		table.insert(mf.enemyguildlist, nam)
		listcounter = listcounter - 1
	end
	gkini.WriteString("MakeFriends-"..GetPlayerName(), "FriendGuilds", spickle(mf.friendguildlist))
	gkini.WriteString("MakeFriends-"..GetPlayerName(), "EnemyGuilds", spickle(mf.enemyguildlist))
	
	mf.enemyguildmap=mf.iListToMap(mf.enemyguildlist)
	mf.friendguildmap=mf.iListToMap(mf.friendguildlist)
	
	HideDialog(mf.ui.guildlistsdlg)
	mf.ui.dlg.active = "YES"
end

--Adds an item to the end of a iup list
function mf.PushListItem(list, item)
	if(not list.value) then list.value = 0 end
	local newval = list.value + 1
	list[tostring(newval)] = item
	list.value = newval
end

function mf.ui.addwhite:action()
	if(not strip_whitespace(mf.ui.whiteentry.value)) then 
		mf.ui.whiteentry.value = ""
		return 
	end
	mf.PushListItem(mf.ui.whitelist, mf.ui.whiteentry.value)
	mf.ui.whiteentry.value = ""
end

function mf.ui.addblack:action()
	if(not strip_whitespace(mf.ui.blackentry.value)) then
		mf.ui.blackentry = ""
		return
	end
	mf.PushListItem(mf.ui.blacklist, mf.ui.blackentry.value)
	mf.ui.blackentry.value = ""
end

function mf.ui.removewhite:action()
	mf.RemoveSelectedListItem(mf.ui.whitelist)
end

function mf.ui.removeblack:action()
	mf.RemoveSelectedListItem(mf.ui.blacklist)
end

--Moves the selected item in the iup list source to the iup list dest
--If sel is specified, that is the item moved from source. If not, vo_listsel is used.
function mf.MoveSelectedListItem(source, dest, sel)
	if(not sel) then
		sel = source.vo_listsel
	end
	local selitem = mf.RemoveSelectedListItem(source, sel)
	mf.PushListItem(dest, selitem)
end

function mf.ui.whitetoblackb:action()
	mf.MoveSelectedListItem(mf.ui.whitelist, mf.ui.blacklist)
end

function mf.ui.blacktowhiteb:action()
	mf.MoveSelectedListItem(mf.ui.blacklist, mf.ui.whitelist)
end

--Lists of people. NSA is watching.
mf.ui.pcontrols = {
	fandecloseb = {"stationbutton", {title =  "Close & Save",expand = "HORIZONTAL"}},

	leftbutton = {"stationbutton", {title =  "<"} },
	rightbutton = {"stationbutton", {title =  ">" }},

	addfriend = {"stationbutton", {title =  "Add as Friend",expand = "HORIZONTAL" }},
	removeselectedfriend = {"stationbutton", {title =  "Remove Selected Friend",expand = "HORIZONTAL" }},
	addenemy = {"stationbutton", {title =  "Add as Enemy",expand = "HORIZONTAL" }},
	removeselectedenemy = {"stationbutton", {title =  "Remove Selected Enemy",expand = "HORIZONTAL" }},
}

mf.BatchAddControls(mf.ui.pcontrols, mf.ui)

mf.ui.enemybox = iup.pdasubsubsublist { value = 0, size = "x350", expand = "HORIZONTAL" }
mf.ui.friendlybox = iup.pdasubsubsublist { value = 0, size = "x350", expand = "HORIZONTAL" }
mf.ui.friendentrybox = iup.text { value = "", expand = "HORIZONTAL"}
mf.ui.enemyentrybox = iup.text {value = "", expand = "HORIZONTAL"}


mf.ui.addremovefriend = iup.vbox {
	iup.label{title = "Friendlies"},
	mf.ui.friendlybox,
	mf.ui.friendentrybox,
	mf.ui.addfriend,
	mf.ui.removeselectedfriend;
	alignment = "ACENTER" 
}
mf.ui.addremoveenemy = iup.vbox {
	iup.label{title = "Enemies"},
	mf.ui.enemybox,
	mf.ui.enemyentrybox,
	mf.ui.addenemy,
	mf.ui.removeselectedenemy;
	alignment = "ACENTER" 
}
mf.ui.transferbuttons = iup.vbox {
	iup.fill{},
	mf.ui.rightbutton,
	mf.ui.leftbutton,
	iup.fill{}
}
mf.ui.fandemid = iup.hbox {
	mf.ui.addremovefriend,
	mf.ui.transferbuttons,
	mf.ui.addremoveenemy;
	alignment = "ACENTER"
}
mf.ui.fandeentry = iup.vbox {
	mf.ui.fandemid
}
	
		
mf.ui.fandemain = iup.pdarootframe {
	iup.pdasubframebg {
		iup.vbox{
			mf.ui.fandeentry,
			iup.fill{},
			iup.hbox {
				mf.ui.fandecloseb;
				--size = "490x"
			};
			alignment = "ACENTER"
		}
	}
}

mf.ui.fandedlg = iup.dialog {
	mf.ui.fandemain;
	border = "NO",
	topmost = "YES",
	resize = "NO",
	maxbox = "NO",
	minbox = "NO",
	menubox = "NO",
	MODAL = "YES"
}
mf.ui.friendnum = 0
mf.ui.enemynum = 0
function mf.ui.friendentrybox:action(c)
	if(c == iup.K_TAB) then
		if(strip_whitespace(mf.ui.friendentrybox.value) == nil) then
			mf.ui.friendentrybox.value = GetLastPrivateSpeaker()
		end
		local name = TabCompleteName(iup.GetAttribute(mf.ui.friendentrybox, "VALUE"))
		if(name ~= nil) then
			iup.SetAttribute(mf.ui.friendentrybox, "VALUE", name)
		end
	end
end

function mf.ui.fandedlg:k_any(c)
	if(c == iup.K_TAB) then
		return iup.IGNORE
	end
	return iup.DEFAULT
end

function mf.ui.enemyentrybox:action(c)
	if(c == iup.K_TAB) then
		if(strip_whitespace(mf.ui.enemyentrybox.value) == nil) then
			mf.ui.enemyentrybox.value = GetLastPrivateSpeaker() or ""
		end
		local name = TabCompleteName(iup.GetAttribute(mf.ui.enemyentrybox, "VALUE"))
		if(name ~= nil) then
			iup.SetAttribute(mf.ui.enemyentrybox, "VALUE", name)
		end
	end
end


function mf.ui.addfriend:action()
	local toadd = mf.ui.friendentrybox.value
	if(strip_whitespace(toadd) == nil) then 
		mf.ui.friendentrybox.value = ""
		return 
	end
	mf.PushListItem(mf.ui.friendlybox, toadd)
	mf.ui.friendentrybox.value = ""
	
end
function mf.ui.addenemy:action()

	local toadd = mf.ui.enemyentrybox.value
	if(strip_whitespace(toadd) == nil) then
		mf.ui.enemyentrybox.value = ""
		return 
	end
	mf.PushListItem(mf.ui.enemybox, toadd)
	mf.ui.enemyentrybox.value = ""

end
function mf.ui.leftbutton:action()
	mf.MoveSelectedListItem(mf.ui.enemybox, mf.ui.friendlybox)

end
function mf.ui.removeselectedenemy:action()
	mf.RemoveSelectedListItem(mf.ui.enemybox)
end
		
function mf.ui.removeselectedfriend:action()
	mf.RemoveSelectedListItem(mf.ui.friendlybox)
end
function mf.ui.rightbutton:action()
	mf.MoveSelectedListItem(mf.ui.friendlybox, mf.ui.enemybox)
end
function mf.ui.fandedlgopen()
	for key, value in pairs(mf.friendslist) do
		mf.PushListItem(mf.ui.friendlybox, value, mf.ui.friendnum)
	end
	for key, value in pairs(mf.enemylist) do
		mf.PushListItem(mf.ui.enemybox, value, mf.ui.enemynum)
	end	
	ShowDialog(mf.ui.fandedlg)
end

function mf.ui.fandeclose()
	mf.enemylist = {}
	mf.friendslist = {}
	local nam = ""
	local listcounter = mf.GetListSize(mf.ui.friendlybox)
	while(listcounter > 0) do
		nam = mf.RemoveSelectedListItem(mf.ui.friendlybox, 1)
		table.insert(mf.friendslist, nam)
		listcounter = listcounter - 1

	end
	listcounter = mf.GetListSize(mf.ui.enemybox)
	while(listcounter > 0) do
		nam = mf.RemoveSelectedListItem(mf.ui.enemybox, 1)
		table.insert(mf.enemylist, nam)
		listcounter = listcounter - 1
	end
	gkini.WriteString("MakeFriends-"..GetPlayerName(), "Friends", spickle(mf.friendslist))
	gkini.WriteString("MakeFriends-"..GetPlayerName(), "Enemies", spickle(mf.enemylist))
	
	mf.enemymap=mf.iListToMap(mf.enemylist)
	mf.friendmap=mf.iListToMap(mf.friendslist)

end

function mf.ui.fandecloseb:action()
	mf.ui.fandeclose()
	HideDialog(mf.ui.fandedlg)
	iup.SetAttribute(mf.ui.dlg, "ACTIVE", "YES")
end

--Presets! Everyone loves presets
--Also, don't care enough to convert this into a titled control batch right now, :effort:
--not a big chunk anyway
mf.ui.presetscloseb = iup.stationbutton { title = "Close", expand = "HORIZONTAL" }
mf.ui.presetsbox = iup.pdasubsubsublist { value = 1, size = "250x200", expand = "HORIZONTAL"}
mf.ui.presetsentrybox = iup.text { value = "", expand = "HORIZONTAL"}
mf.ui.loadselectedpreset = iup.stationbutton { title = "Load Selected Preset", expand = "HORIZONTAL" }
mf.ui.removeselectedpreset = iup.stationbutton { title = "Remove Selected Preset", expand = "HORIZONTAL" }
mf.ui.loaddefaultpreset = iup.stationbutton { title = "Load Default Preset", expand = "HORIZONTAL" }
mf.ui.savepresetname = iup.text { value = "", expand = "HORIZONTAL" }
mf.ui.savepresetokb = iup.stationbutton { title = "Save Preset" }
mf.ui.savepresetnob = iup.stationbutton { title = "Cancel" }


mf.ui.presetsmain = iup.pdarootframe {
	iup.pdasubframebg {
		iup.hbox{
			iup.vbox{
				mf.ui.presetsbox,
				alignment = "ACENTER"
			},
			iup.fill{},
			iup.vbox{
				mf.ui.loadselectedpreset,
				mf.ui.removeselectedpreset,
				iup.fill{},
				mf.ui.loaddefaultpreset,
				mf.ui.presetscloseb;
				alignment = "ACENTER"
			}	
		}
	}
}


mf.ui.presetsdlg = iup.dialog {
	mf.ui.presetsmain;
	border = "NO",
	topmost = "YES",
	resize = "NO",
	maxbox = "NO",
	minbox = "NO",
	menubox = "NO",
	--size = "500x500",
	MODAL = "YES"
}

mf.ui.savepresetmain = iup.pdarootframe {
	iup.pdasubframebg {
		iup.vbox{
			iup.label { title = "Enter New Preset Name:" },
			mf.ui.savepresetname,
			iup.hbox {
				iup.fill{},
				mf.ui.savepresetokb,
				mf.ui.savepresetnob
			}
		}
	}
}


mf.ui.savepresetdlg = iup.dialog {
	mf.ui.savepresetmain;
	border = "NO",
	topmost = "YES",
	resize = "NO",
	maxbox = "NO",
	minbox = "NO",
	menubox = "NO",
	--size = "500x500",
	MODAL = "YES"
}

function mf.ui.savepresetnob:action()
	iup.SetAttribute(mf.ui.savepresetname, "VALUE", "")
	HideDialog(mf.ui.savepresetdlg)
	iup.SetAttribute(mf.ui.dlg, "ACTIVE", "YES")
end

--Finds a string in table. Returns the index if it finds it, false otherwise.
function mf.IsStringInTable(intable, fstring)
	for key, value in pairs(intable) do
		if(string.lower(fstring) == string.lower(value)) then
			return key
		end
	end
	return false
end

function mf.ui.savepresetokb:action()
	local name = iup.GetAttribute(mf.ui.savepresetname, "VALUE")
	if(name == "") then
		return
	end
	if(mf.IsStringInTable(mf.presets, name) == false) then
		table.insert(mf.presets, name)
		mf.SavePresets()
	end
	mf.SaveSettings(name)--rename
	mf.curpreset = name
	iup.SetAttribute(mf.ui.savepresetname, "VALUE", "")
	gkini.WriteString("MakeFriends-"..GetPlayerName() or "", "CurrentPreset", name)
	HideDialog(mf.ui.savepresetdlg)
	iup.SetAttribute(mf.ui.dlg, "ACTIVE", "YES")
end
	
function mf.ui.savepresetb:action()
	iup.SetAttribute(mf.ui.savepresetname, "VALUE", "")
	ShowDialog(mf.ui.savepresetdlg)
	iup.SetAttribute(mf.ui.dlg, "ACTIVE", "NO")
end
function mf.ui.presetsdlgopen()
	mf.ui.presetsnum = 0
	for key, value in pairs(mf.presets) do
		mf.ui.presetsnum = mf.ui.presetsnum + 1
		iup.SetAttribute(mf.ui.presetsbox, "VALUE", mf.ui.presetsnum)
		iup.SetAttribute(mf.ui.presetsbox, tostring(mf.ui.presetsnum), value)
	end
	ShowDialog(mf.ui.presetsdlg)
	iup.SetAttribute(mf.ui.dlg, "ACTIVE", "NO")
end

function mf.ui.loadselectedpreset:action()
	local sel = iup.GetAttribute(mf.ui.presetsbox, "VO_LISTSEL")
	if(sel == 0) then
		return
	end
	local selpreset = iup.GetAttribute(mf.ui.presetsbox, tostring(sel))
	if(selpreset ~= nil) then
		mf.LoadSettings(selpreset)--rename
	end
	mf.GetFriends()--rename
	gkini.WriteString("MakeFriends-"..GetPlayerName() or "", "CurrentPreset", selpreset)
	HideDialog(mf.ui.presetsdlg)
	iup.SetAttribute(mf.ui.dlg, "ACTIVE", "YES")
end

function mf.ui.removeselectedpreset:action()
	if(iup.GetAttribute(mf.ui.presetsbox, "VO_LISTSEL") ~= 0) then
		local selection = tostring(iup.GetAttribute(mf.ui.presetsbox, "VO_LISTSEL"))
		local replacement = iup.GetAttribute(mf.ui.presetsbox, tostring(mf.ui.presetsnum))
		iup.SetAttribute(mf.ui.presetsbox, selection, replacement)
		iup.SetAttribute(mf.ui.presetsbox, tostring(mf.ui.presetsnum), nil)
		mf.ui.presetsnum = mf.ui.presetsnum - 1
		iup.SetAttribute(mf.ui.presetsbox, "VALUE", mf.ui.presetsnum)
	end
end
function mf.ui.presetscloseb:action()
	mf.presets = {}
	while(mf.ui.presetsnum > 0) do
		table.insert(mf.presets, iup.GetAttribute(mf.ui.presetsbox, tostring(mf.ui.presetsnum)))
		iup.SetAttribute(mf.ui.presetsbox, tostring(mf.ui.presetsnum), nil)
		mf.ui.presetsnum = mf.ui.presetsnum - 1
		iup.SetAttribute(mf.ui.presetsbox, "VALUE", mf.ui.presetsnum)
	end
	mf.SavePresets()--rename
	HideDialog(mf.ui.presetsdlg)
	iup.SetAttribute(mf.ui.dlg, "ACTIVE", "YES")
end

function mf.ui.loaddefaultpreset:action()
	mf.LoadSettings("Default")--rename
	mf.GetFriends()--rename
	HideDialog(mf.ui.presetsdlg)
	iup.SetAttribute(mf.ui.dlg, "ACTIVE", "YES")
end

-- Copypasta toggle color functions
local function fac_color(self, v)
	if(v == 1) then
		iup.SetAttribute(self, "FGCOLOR", "0 255 0")
	else
		iup.SetAttribute(self, "FGCOLOR", "255 0 0")
	end
end

mf.ui.unaligned.action = fac_color
mf.ui.serco.action = fac_color
mf.ui.itani.action = fac_color
mf.ui.uit.action = fac_color
mf.ui.aeolus.action = fac_color
mf.ui.ineubis.action = fac_color
mf.ui.xangxi.action = fac_color
mf.ui.corvus.action = fac_color
mf.ui.tpg.action = fac_color
mf.ui.axia.action = fac_color
mf.ui.valent.action = fac_color
mf.ui.orion.action = fac_color
mf.ui.guild.action = fac_color
mf.ui.group.action = fac_color
--mf.ui.NPC.action = fac_color
mf.ui.buddies.action = fac_color
mf.ui.tunguska.action = fac_color
mf.ui.biocom.action = fac_color

local function npc_color(self,_,v)
	local c = (v==1 and "255 204 241") or (v==2 and "255 0 0") or (v == 3 and "0 255 0") or "255 255 255"
	iup.SetAttribute(self, "FGCOLOR", c)
end
mf.ui.hive.action = function(self,_, v) npc_color(mf.ui.hivestat,_, v) end
mf.ui.statg.action = function(self,_, v) npc_color(mf.ui.statgstat,_, v) end
mf.ui.border.action = function(self,_,v) npc_color(mf.ui.borderstat,_,v) end
mf.ui.sf.action = function(self,_, v) npc_color(mf.ui.sfstat,_, v) end
mf.ui.conq.action = function(self,_, v) npc_color(mf.ui.conqstat,_, v) end
mf.ui.norm.action = function(self,_, v) npc_color(mf.ui.normstat,_, v) end
